"""Initial db

Revision ID: 406a3ee5874d
Revises: 
Create Date: 2023-09-05 15:06:11.277897

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '406a3ee5874d'
down_revision = None
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('account',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('slug', sa.String(), nullable=False),
    sa.Column('temporary', sa.Boolean(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('slug')
    )
    op.create_table('user',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('email', sa.String(), nullable=False),
    sa.Column('validated', sa.Boolean(), nullable=False),
    sa.Column('password_hash', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('email')
    )
    op.create_table('webclient',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('ip_address', sa.String(), server_default='', nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('account_to_user',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('account_id', sa.String(), nullable=False),
    sa.Column('user_id', sa.String(), nullable=False),
    sa.Column('role', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['account_id'], ['account.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id', 'account_id', 'user_id')
    )
    op.create_table('apikey',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('account_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['account_id'], ['account.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('key')
    )
    op.create_table('applicationclient',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('account_id', sa.String(), nullable=False),
    sa.Column('routing_code', sa.String(), nullable=False),
    sa.Column('ip_address', sa.String(), server_default='', nullable=False),
    sa.ForeignKeyConstraint(['account_id'], ['account.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('authtoken',
    sa.Column('token', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('user_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('token')
    )
    op.create_table('usagebucket',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('account_id', sa.String(), nullable=False),
    sa.Column('start_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('seconds', sa.Float(), nullable=False),
    sa.ForeignKeyConstraint(['account_id'], ['account.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('application',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('account_id', sa.String(), nullable=False),
    sa.Column('client_id', sa.String(), nullable=False),
    sa.Column('routing_code', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('slug', sa.String(), nullable=False),
    sa.Column('color', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['account_id'], ['account.id'], ),
    sa.ForeignKeyConstraint(['client_id'], ['applicationclient.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('applicationsession',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('create_date', sa.DateTime(), server_default=sa.text('now()'), nullable=False),
    sa.Column('application_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['application_id'], ['application.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('applicationsession')
    op.drop_table('application')
    op.drop_table('usagebucket')
    op.drop_table('authtoken')
    op.drop_table('applicationclient')
    op.drop_table('apikey')
    op.drop_table('account_to_user')
    op.drop_table('webclient')
    op.drop_table('user')
    op.drop_table('account')
    # ### end Alembic commands ###
